]> arthur.barton.de Git - bup.git/blobdiff - cmd/tag-cmd.py
vint: remove unnecessary condition
[bup.git] / cmd / tag-cmd.py
index a624e8b8ace127d1ea434cad72723468448a61c9..2fc068ddc7189eb535a31def25681480fc7cc9cb 100755 (executable)
@@ -1,50 +1,51 @@
-#!/usr/bin/env python
-"""Tag a commit in the bup repository.
-Creating a tag on a commit can be used for avoiding automatic cleanup from
-removing this commit due to old age.
+#!/bin/sh
+"""": # -*-python-*-
+bup_python="$(dirname "$0")/bup-python" || exit $?
+exec "$bup_python" "$0" ${1+"$@"}
 """
-import sys
-import os
+# end of bup preamble
+
+from __future__ import absolute_import, print_function
+import os, sys
 
 from bup import git, options
-from bup.helpers import *
+from bup.helpers import debug1, handle_ctrl_c, log
 
+# FIXME: review for safe writes.
 
 handle_ctrl_c()
 
 optspec = """
 bup tag
-bup tag <tag name> <commit>
-bup tag -d <tag name>
+bup tag [-f] <tag name> <commit>
+bup tag [-f] -d <tag name>
 --
 d,delete=   Delete a tag
+f,force     Overwrite existing tag, or ignore missing tag when deleting
 """
 
-o = options.Options('bup tag', optspec)
+o = options.Options(optspec)
 (opt, flags, extra) = o.parse(sys.argv[1:])
 
 git.check_repo_or_die()
 
-if opt.delete:
-    tag_file = git.repo('refs/tags/%s' % opt.delete)
-    debug1("tag file: %s\n" % tag_file)
-    if not os.path.exists(tag_file):
-        log("bup: error: tag '%s' not found." % opt.delete)
-        sys.exit(1)
+tags = [t for sublist in git.tags().values() for t in sublist]
 
-    try:
-        os.unlink(tag_file)
-    except OSError, e:
-        log("bup: error: unable to delete tag '%s': %s" % (opt.delete, e))
+if opt.delete:
+    # git.delete_ref() doesn't complain if a ref doesn't exist.  We
+    # could implement this verification but we'd need to read in the
+    # contents of the tag file and pass the hash, and we already know
+    # about the tag's existance via "tags".
+    if not opt.force and opt.delete not in tags:
+        log("error: tag '%s' doesn't exist\n" % opt.delete)
         sys.exit(1)
-
+    tag_file = 'refs/tags/%s' % opt.delete
+    git.delete_ref(tag_file)
     sys.exit(0)
 
-tags = [t for sublist in git.tags().values() for t in sublist]
-
 if not extra:
     for t in tags:
-        print t
+        print(t)
     sys.exit(0)
 elif len(extra) < 2:
     o.fatal('no commit ref or hash given.')
@@ -54,8 +55,8 @@ if not tag_name:
     o.fatal("tag name must not be empty.")
 debug1("args: tag name = %s; commit = %s\n" % (tag_name, commit))
 
-if tag_name in tags:
-    log("bup: error: tag '%s' already exists" % tag_name)
+if tag_name in tags and not opt.force:
+    log("bup: error: tag '%s' already exists\n" % tag_name)
     sys.exit(1)
 
 if tag_name.startswith('.'):
@@ -63,23 +64,23 @@ if tag_name.startswith('.'):
 
 try:
     hash = git.rev_parse(commit)
-except git.GitError, e:
+except git.GitError as e:
     log("bup: error: %s" % e)
     sys.exit(2)
 
 if not hash:
-    log("bup: error: commit %s not found." % commit)
+    log("bup: error: commit %s not found.\n" % commit)
     sys.exit(2)
 
 pL = git.PackIdxList(git.repo('objects/pack'))
 if not pL.exists(hash):
-    log("bup: error: commit %s not found." % commit)
+    log("bup: error: commit %s not found.\n" % commit)
     sys.exit(2)
 
 tag_file = git.repo('refs/tags/%s' % tag_name)
 try:
-    tag = file(tag_file, 'w')
-except OSError, e:
+    tag = open(tag_file, 'w')
+except OSError as e:
     log("bup: error: could not create tag '%s': %s" % (tag_name, e))
     sys.exit(3)